## mingw-w64-paraview-5.13.3-1.src.tar.zst

=== VTK/ThirdParty/netcdf/vtknetcdf/CMakeLists.txt ===
set(NC_VERSION_MAJOR 4)
set(NC_VERSION_MINOR 9)
set(NC_VERSION_PATCH 2)
set(NC_VERSION_NOTE "")
set(netCDF_VERSION ${NC_VERSION_MAJOR}.${NC_VERSION_MINOR}.${NC_VERSION_PATCH}${NC_VERSION_NOTE})
set(VERSION ${netCDF_VERSION})
set(NC_VERSION ${netCDF_VERSION})
set(NC_DISPATCH_VERSION 3)

set(sources
  libdispatch/datt.c
  libdispatch/dattget.c
  libdispatch/dattinq.c
  libdispatch/dattput.c
  libdispatch/dauth.c
  libdispatch/daux.c
  libdispatch/dcompound.c
  libdispatch/dcopy.c
  libdispatch/dcrc32.c
  libdispatch/dcrc64.c
  libdispatch/ddim.c
  libdispatch/ddispatch.c
  libdispatch/denum.c
  libdispatch/derror.c
  libdispatch/dfile.c
  libdispatch/dfilter.c
  libdispatch/dgroup.c
  libdispatch/dinfermodel.c
  libdispatch/dinstance.c
  libdispatch/dinternal.c
  libdispatch/dnotnc3.c
  libdispatch/dnotnc4.c
  libdispatch/doffsets.c
  libdispatch/dopaque.c
  libdispatch/dparallel.c
  libdispatch/dpathmgr.c
  libdispatch/drc.c
  libdispatch/dreadonly.c
  libdispatch/ds3util.c
  libdispatch/dstring.c
  libdispatch/dtype.c
  libdispatch/dutf8.c
  libdispatch/dutil.c
  libdispatch/dvar.c
  libdispatch/dvarget.c
  libdispatch/dvarinq.c
  libdispatch/dvarput.c
  libdispatch/dvlen.c
  libdispatch/nc.c
  libdispatch/ncbytes.c
  libdispatch/ncexhash.c
  libdispatch/nchashmap.c
  libdispatch/ncjson.c
  libdispatch/nclist.c
  libdispatch/nclistmgr.c
  libdispatch/nclog.c
  libdispatch/nctime.c
  libdispatch/ncuri.c
  libdispatch/ncxcache.c
  libdispatch/utf8proc.c
  libdispatch/utf8proc.h

  liblib/nc_initialize.c

  libsrc/attr.c
  libsrc/dim.c
  libsrc/lookup3.c
  libsrc/memio.c
  libsrc/nc3dispatch.c
  libsrc/nc3internal.c
  libsrc/ncio.c
  libsrc/ncx.c
  libsrc/posixio.c
  libsrc/putget.c
  libsrc/v1hpg.c
  libsrc/var.c

  libsrc4/nc4attr.c
  libsrc4/nc4cache.c
  libsrc4/nc4dim.c
  libsrc4/nc4dispatch.c
  libsrc4/nc4grp.c
  libsrc4/nc4internal.c
  libsrc4/nc4type.c
  libsrc4/nc4var.c
  libsrc4/ncfunc.c
  libsrc4/ncindex.c

  libhdf5/nc4hdf.c
  libhdf5/nc4info.c
  libhdf5/hdf5attr.c
  libhdf5/hdf5debug.c
  libhdf5/hdf5dim.c
  libhdf5/hdf5file.c
  libhdf5/hdf5filter.c
  libhdf5/hdf5grp.c
  libhdf5/hdf5type.c
  libhdf5/hdf5internal.c
  libhdf5/hdf5create.c
  libhdf5/hdf5open.c
  libhdf5/hdf5var.c
  libhdf5/nc4mem.c
  libhdf5/nc4memcb.c
  libhdf5/hdf5dispatch.c
  libhdf5/hdf5set_format_compatibility.c
  )

set(CHUNK_CACHE_NELEMS 1009)
set(CHUNK_CACHE_PREEMPTION 0.75)
set(CHUNK_CACHE_SIZE 4194304)
set(DEFAULT_CHUNKS_IN_CACHE 10)
set(DEFAULT_CHUNK_SIZE 4194304)
set(MAX_DEFAULT_CACHE_SIZE 67108864)
set(NCIO_MINBLOCKSIZE 256)

set(REGEDIT ${WIN32})
set(JNA 1)
set(NO_NETCDF_2 1)
set(RELAX_COORD_BOUND 0)
set(USE_CDF4 0)
set(USE_DAP 0)
set(USE_DISKLESS 1)
set(USE_FFIO 0)
set(USE_FSYNC 0)
set(USE_HDF4 0)
set(USE_HDF5 1)
set(USE_MMAP 0)
set(USE_NETCDF4 1)
set(USE_NETCDF_2 0)
set(USE_PARALLEL 0)
set(USE_PARALLEL4 0)
set(USE_PARALLEL_MPIO 0)
set(USE_PARALLEL_POSIX 0)
set(USE_PNETCDF 0)
set(USE_ZLIB 0)

set(ENABLE_CDF5 ON)
check_type_size("size_t" SIZEOF_SIZE_T)
if (SIZEOF_SIZE_T EQUAL 4)
  if (ENABLE_CDF5) # enable or auto
    string(TOUPPER ${ENABLE_CDF5} ENABLE_CDF5)
    if (ENABLE_CDF5 AND NOT ENABLE_CDF5 STREQUAL "AUTO") # explicitly enabled
      message(STATUS "Unable to support CDF5 feature because size_t is less than 8 bytes")
    endif ()
    set(ENABLE_CDF5 OFF) # cannot support CDF5
    set(USE_CDF5 OFF) # cannot support CDF5
  endif ()
else ()
  if (ENABLE_CDF5) # explicitly set by user or not set
    set(USE_CDF5 ON)
  else () # explicitly disabled by user
    set(USE_CDF5 OFF)
  endif ()
endif ()

if (REGEDIT)
  list(APPEND sources
    libdispatch/dreg.c)
endif ()

function(is_enabled feature ret_val)
  if(${feature})
    set("NC_${ret_val}" 1 PARENT_SCOPE)
  else()
    set("NC_${ret_val}" 0 PARENT_SCOPE)
  endif()
endfunction()

is_enabled(ENABLE_V2_API HAS_NC2)
is_enabled(ENABLE_NETCDF_4 HAS_NC4)
is_enabled(ENABLE_HDF4 HAS_HDF4)
is_enabled(ENABLE_NETCDF_4 HAS_HDF5)
is_enabled(STATUS_PNETCDF HAS_PNETCDF)
is_enabled(STATUS_PARALLEL HAS_PARALLEL)
is_enabled(ENABLE_PARALLEL4 HAS_PARALLEL4)
is_enabled(ENABLE_DAP HAS_DAP)
is_enabled(ENABLE_DAP HAS_DAP2)
is_enabled(ENABLE_DAP4 HAS_DAP4)
is_enabled(USE_DISKLESS HAS_DISKLESS)
is_enabled(USE_MMAP HAS_MMAP)
is_enabled(JNA HAS_JNA)
is_enabled(STATUS_RELAX_COORD_BOUND RELAX_COORD_BOUND)
is_enabled(USE_CDF5 HAS_CDF5)

set(USE_STDIO 0)
set(NC_HAS_LOGGING 0)

include(CheckSymbolExists)
check_symbol_exists("_filelengthi64" "io.h" HAVE_FILE_LENGTH_I64)
check_symbol_exists("alloca" "alloca.h" HAVE_ALLOCA)
check_symbol_exists("isfinite" "math.h" HAVE_DECL_ISFINITE)
check_symbol_exists("isinf" "math.h" HAVE_DECL_ISINF)
check_symbol_exists("isnan" "math.h" HAVE_DECL_ISNAN)
check_symbol_exists("fsync" "unistd.h" HAVE_FSYNC)
check_symbol_exists("mktemp" "stdlib.h" HAVE_MKTEMP)
check_symbol_exists("getpagesize" "unistd.h" HAVE_GETPAGESIZE)
check_symbol_exists("getrlimit" "sys/time.h;sys/resource.h" HAVE_GETRLIMIT)
check_symbol_exists("memmove" "string.h" HAVE_MEMMOVE)
check_symbol_exists("mkstemp" "stdlib.h" HAVE_MKSTEMP)
check_symbol_exists("random" "stdlib.h" HAVE_RANDOM)
check_symbol_exists("snprintf" "stdio.h" HAVE_SNPRINTF)
check_symbol_exists("strdup" "string.h" HAVE_STRDUP)
check_symbol_exists("strndup" "string.h" HAVE_STRNDUP)
check_symbol_exists("strlcat" "string.h" HAVE_STRLCAT)
check_symbol_exists("st_blocksize" "sys/stat.h" HAVE_STRUCT_STAT_ST_BLKSIZE)
check_symbol_exists("sysconf" "unistd.h" HAVE_SYSCONF)

set(HAVE_HDF5_H 1)
set(H5_USE_16_API 1) # Enable HDF5 1.6.x Compatibility(Required)
if (VTK_MODULE_USE_EXTERNAL_VTK_hdf5)
  set(CMAKE_REQUIRED_INCLUDES_save "${CMAKE_REQUIRED_INCLUDES}")
  list(APPEND CMAKE_REQUIRED_INCLUDES
    "${CMAKE_CURRENT_BINARY_DIR}/../../hdf5")
  # The symbol detections can still fail for an external HDF5 that isn't in a
  # standard location. We need generate-time knowledge to get the real include
  # directories. These checks should really be replaced at some point with some
  # compile-time logic if at all possible (version checks, preprocessor
  # detections, etc.).
  check_symbol_exists("H5free_memory" "vtk_hdf5.h" HDF5_HAS_H5FREE)
  check_symbol_exists("H5Pset_all_coll_metadata_ops" "vtk_hdf5.h" H5PSET_ALL_COLL_METADATA_OPS)
  check_symbol_exists("H5Pset_libver_bounds" "vtk_hdf5.h" HDF5_HAS_LIBVER_BOUNDS)
  check_symbol_exists("HDF5_PARALLEL" "vtk_hdf5.h" HDF5_PARALLEL)
  set(CMAKE_REQUIRED_INCLUDES "${CMAKE_REQUIRED_INCLUDES_save}")
else ()
  set(HDF5_HAS_H5FREE 1)
  set(H5PSET_ALL_COLL_METADATA_OPS 1)
  set(HDF5_HAS_LIBVER_BOUNDS 1)
  set(HDF5_PARALLEL 0)
endif ()

include(CheckIncludeFiles)
check_include_file("alloca.h" HAVE_ALLOCA_H)
check_include_file("fcntl.h" HAVE_FCNTL_H)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("malloc.h" HAVE_MALLOC_H)
check_include_file("stdarg.h" HAVE_STDARG_H)
check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("stdio.h" HAVE_STDIO_H)
check_include_file("stdlib.h" HAVE_STDLIB_H)
check_include_file("string.h" HAVE_STRING_H)
check_include_file("sys/param.h" HAVE_SYS_PARAM_H)
check_include_file("sys/resource.h" HAVE_SYS_RESOURCE_H)
check_include_file("sys/stat.h" HAVE_SYS_STAT_H)
check_include_file("sys/types.h" HAVE_SYS_TYPES_H)
check_include_file("unistd.h" HAVE_UNISTD_H)

include(CheckTypeSize)
check_type_size("longlong" HAVE_LONGLONG)
check_type_size("long long int" HAVE_LONG_LONG_INT)
check_type_size("ssize_t" HAVE_SSIZE_T)
check_type_size("uchar" HAVE_UCHAR)
check_type_size("uint" HAVE_UINT)
check_type_size("schar" HAVE_SCHAR)
check_type_size("ushort" HAVE_USHORT)
check_type_size("double" SIZEOF_DOUBLE)
check_type_size("float" SIZEOF_FLOAT)
check_type_size("int" SIZEOF_INT)
check_type_size("long" SIZEOF_LONG)
check_type_size("long long" SIZEOF_LONG_LONG)
check_type_size("off_t" SIZEOF_OFF_T)
check_type_size("short" SIZEOF_SHORT)
check_type_size("size_t" SIZEOF_SIZE_T)
check_type_size("unsigned char" SIZEOF_UNSIGNED_CHAR)
check_type_size("unsigned int" SIZEOF_UNSIGNED_INT)
check_type_size("unsigned long long" SIZEOF_UNSIGNED_LONG_LONG)
check_type_size("unsigned short int" SIZEOF_UNSIGNED_SHORT_INT)
check_type_size("uint64_t" HAVE_UINT64_T)
check_type_size("ptrdiff_t" HAVE_PTRDIFF_T)

set(SIZEOF_UCHAR ${HAVE_UCHAR})
set(SIZEOF_UINT ${HAVE_UINT})
set(SIZEOF_SCHAR ${HAVE_SCHAR})
set(SIZEOF_USHORT ${HAVE_USHORT})
set(SIZEOF_VOIDP ${CMAKE_SIZEOF_VOID_P})

include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

set(PACKAGE_VERSION "${NC_VERSION_MAJOR}.${NC_VERSION_MINOR}.${NC_VERSION_PATCH}")

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/include/netcdf_meta.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/include/netcdf_meta.h"
  @ONLY)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/include/netcdf_dispatch.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/include/netcdf_dispatch.h"
  @ONLY)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtk_netcdf_config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtk_netcdf_config.h"
  @ONLY)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/config.h"
  @ONLY)

set(headers
  include/netcdf.h
  include/netcdf_filter_build.h
  include/vtk_netcdf_mangle.h
  "${CMAKE_CURRENT_BINARY_DIR}/include/netcdf_dispatch.h"
  "${CMAKE_CURRENT_BINARY_DIR}/include/netcdf_meta.h"
  "${CMAKE_CURRENT_BINARY_DIR}/vtk_netcdf_config.h")

vtk_module_add_module(VTK::netcdf
  HEADER_DIRECTORIES
  SOURCES ${sources}
  HEADERS ${headers}
  HEADERS_SUBDIR "vtknetcdf")
target_compile_definitions(netcdf
  PRIVATE
    HAVE_CONFIG_H)
if (WIN32 AND BUILD_SHARED_LIBS)
  target_compile_definitions(netcdf
    PRIVATE
      DLL_EXPORT
      DLL_NETCDF)
endif ()
target_include_directories(netcdf
  PRIVATE
    "${CMAKE_CURRENT_SOURCE_DIR}/include"
    "${CMAKE_CURRENT_SOURCE_DIR}/libdispatch"
    "${CMAKE_CURRENT_SOURCE_DIR}/libsrc"
    "${CMAKE_CURRENT_SOURCE_DIR}/libsrc4"
    "${CMAKE_CURRENT_BINARY_DIR}/include")
if (HDF5_PARALLEL)
  if (NOT TARGET VTK::mpi)
    message(FATAL_ERROR
      "HDF5 is parallel, but VTK's MPI support was not available; this is not "
      "supported.")
  endif ()
  vtk_module_link(VTK::netcdf
    INTERFACE
      VTK::mpi)
endif ()

if (UNIX)
  # link against the math library.
  target_link_libraries(netcdf
    PRIVATE
      m)
endif ()

=== VTK/Charts/Core/Testing/Cxx/CMakeLists.txt ===
set(TestChartUnicode_ARGS
  DATA{../Data/Fonts/DejaVuSans.ttf}
  -E 25
  )
set(TestChartsOn3D_ARGS
  -E 16
  )
set(TestColorTransferFunction_ARGS
  -E 80
  )
set(TestContextUnicode_ARGS
  DATA{../Data/Fonts/DejaVuSans.ttf}
  )
set(TestControlPointsHandleItem_ARGS
  -E 30
  )
set(TestLinePlot_ARGS
  -E 25
  )
set(TestLinePlot2_ARGS
  -E 25
  )
set(TestLinePlotInteraction_ARGS
  -E 25
  )
set(TestMultipleRenderers_ARGS
  -E 25
  )
set(TestMultipleScalarsToColors_ARGS
  -E 25
  )
set(TestParallelCoordinates_ARGS
  -E 15
  )
set(TestParallelCoordinatesDouble_ARGS
  -E 15
  )

vtk_add_test_cxx(vtkChartsCoreCxxTests tests
  TestAdjustLowerBoundForLogPlot.cxx
  TestContextScene.cxx,NO_DATA,NO_VALID
  TestColorTransferControlPointsItem.cxx,NO_DATA,NO_VALID
  TestCompositeControlPointsItem.cxx,NO_DATA,NO_VALID
  TestControlPointsItemEvents.cxx,NO_DATA,NO_VALID
  TestAreaPlot.cxx
  TestAxes.cxx
  TestAxes2.cxx
  TestBagPlot.cxx
  TestBarGraph.cxx
  TestBarGraphHorizontal.cxx
  TestBarGraphSelection.cxx
  TestBoxPlot.cxx
  TestBoxPlot2.cxx
  TestCategoryLegend.cxx
  TestColorTransferFunction.cxx
  TestChartBadPoints.cxx
  TestChartDouble.cxx
  TestChartDoubleColors.cxx
  TestChartDoubleColorsOpaque.cxx
  TestChartLogScaleUpdates.cxx
  TestChartMatrix.cxx
  TestChartMatrix2.cxx
  TestChartMatrix3.cxx
  TestChartPicking.cxx,NO_DATA,NO_VALID
  TestChartTileScaling.cxx
  TestChartUnicode.cxx
  TestChartsOn3D.cxx
  TestChartXYInvertedAxis.cxx
  TestChartXYZ.cxx
  TestChartXYZMarginsRotations.cxx
  TestChartXYZOuterEdgeLabelling.cxx
  TestChartXYZUnconstrained.cxx
  TestContext.cxx
  TestContextArea.cxx
  TestContextAreaFixedAspect.cxx
  TestContextAreaFixedMargins.cxx
  TestContextAreaFixedRect.cxx
  TestContextImage.cxx
  TestContextItemStacking.cxx
  TestContextUnicode.cxx
  TestControlPointsHandleItem.cxx
  TestDiagram.cxx
  TestFunctionalBagPlot.cxx
  TestHistogram2D.cxx
  TestHistogram2DComponent.cxx
  TestHistogram2DMagnitude.cxx
  TestInteractiveChartXYZ.cxx
  TestLegendHiddenPlots.cxx
  TestLinePlot.cxx
  TestLinePlotDouble.cxx
  TestLinePlotDouble2.cxx
  TestLinePlot3D.cxx
  TestLinePlotAxisFonts.cxx
  TestLinePlot2.cxx
  TestLinePlotInteraction.cxx
  TestLinePlotSelection.cxx
  TestLinePlotSelection2.cxx
  TestLinePlotSelectionMultiBlock.cxx
  TestMultipleChartRenderers.cxx
  TestMultipleRenderers.cxx
  TestMultipleScalarsToColors.cxx
  TestParallelCoordinates.cxx
  TestParallelCoordinatesDouble.cxx
  TestParallelCoordinatesLegend.cxx
  TestParallelCoordinatesSelection.cxx,NO_VALID
  TestPieChart.cxx
  TestPlotBarRangeHandlesItem.cxx,NO_DATA,NO_VALID
  TestPlotMatrix.cxx
  TestPlotRangeHandlesItem.cxx,NO_DATA,NO_VALID
  TestPropItem.cxx
  TestRangeHandlesItemEvents.cxx,NO_DATA,NO_VALID
  TestScalarsToColors.cxx
  TestScatterPlot.cxx
  TestScatterPlotMatrix.cxx
  TestScatterPlotMatrixHistogram.cxx
  TestScatterPlotMatrixVehicles.cxx
  TestScatterPlotMatrixVisible.cxx
  TestScientificPlot.cxx
  TestStackedBarGraph.cxx
  TestStackedPlot.cxx
  TestSurfacePlot.cxx
  TestZoomAxis.cxx
  TestZoomIndividualAxis.cxx
  )
vtk_test_cxx_executable(vtkChartsCoreCxxTests tests
  DISABLE_FLOATING_POINT_EXCEPTIONS
  RENDERING_FACTORY
  )

=== VTK/Filters/HyperTree/Testing/Cxx/CMakeLists.txt ===
# ---------------------------------------------
# outline of dualfilter is wrong sometime
# ---------------------------------------------
#   TestHyperTreeGridTernary3DDualContour.cxx
#   TestHyperTreeGridTernary3DDualContourMaterial.cxx
#   TestHyperTreeGridTernary3DAxisCut.cxx
#   TestHyperTreeGridTernary3DAxisCutMaterial.cxx
#   TestHyperTreeGridTernary3DPlaneCutterMaterial.cxx
#   TestHyperTreeGridTernary3DPlaneCutterDualMaterial.cxx
#   TestHyperTreeGridToDualGrid.cxx

set(test_sources
  TestHyperTreeGrid2DInterfaceShift.cxx
  TestHyperTreeGrid3DAxisCutCoincidentPlane.cxx
  TestHyperTreeGrid3DIntercepts.cxx
  TestHyperTreeGrid3DInterface.cxx
  TestHyperTreeGrid3DSimpleInterface.cxx
  TestHyperTreeGridBinary1DFeatureEdges.cxx
  TestHyperTreeGridBinary2D.cxx
  TestHyperTreeGridBinary2DAxisClipBox.cxx
  TestHyperTreeGridBinary2DAxisClipEllipse.cxx
  TestHyperTreeGridBinary2DAxisClipPlanes.cxx
  TestHyperTreeGridBinary2DAxisReflectionXCenter.cxx
  TestHyperTreeGridBinary2DAxisReflectionXCenterMaterial.cxx
  TestHyperTreeGridBinary2DAxisReflectionYCenter.cxx
  TestHyperTreeGridBinary2DAxisReflectionYCenterMaterial.cxx
  TestHyperTreeGridBinary2DCellCenters.cxx
  TestHyperTreeGridBinary2DCellCentersMaterial.cxx
  TestHyperTreeGridBinary2DContour.cxx
  TestHyperTreeGridBinary2DContourMaterial.cxx
  TestHyperTreeGridBinary2DDepthLimiter.cxx
  TestHyperTreeGridBinary2DDepthLimiterMaterial.cxx
  TestHyperTreeGridBinary2DFeatureEdges.cxx
  TestHyperTreeGridBinary2DIJK.cxx
  TestHyperTreeGridBinary2DInterfaceMaterial.cxx
  TestHyperTreeGridBinary2DMaterial.cxx
  TestHyperTreeGridBinary2DMaterialIJK.cxx
  TestHyperTreeGridBinary2DThreshold.cxx
  TestHyperTreeGridBinary2DThresholdImplicit.cxx
  TestHyperTreeGridBinary2DThresholdDeep.cxx
  TestHyperTreeGridBinary2DThresholdMaterial.cxx
  TestHyperTreeGridBinary2DThresholdMaterialDeep.cxx
  TestHyperTreeGridBinary2DThresholdMaterialImplicit.cxx
  TestHyperTreeGridBinary2DVector.cxx
  TestHyperTreeGridBinary2DVectorAxisReflectionXCenter.cxx
  TestHyperTreeGridBinary2DVectorAxisReflectionYCenter.cxx
  TestHyperTreeGridBinary3DContour.cxx
  TestHyperTreeGridBinary3DContourDecomposePolyhedra.cxx
  TestHyperTreeGridBinary3DContourImplicit.cxx
  TestHyperTreeGridBinary3DContourImplicitInteger.cxx,NO_VALID,NO_OUTPUT
  TestHyperTreeGridBinary3DFeatureEdges.cxx, LOOSE_VALID
  TestHyperTreeGridBinary3DGeometry.cxx
  TestHyperTreeGridBinaryClipPlanes.cxx
  TestHyperTreeGridBinaryEllipseMaterial.cxx
  TestHyperTreeGridBinaryHyperbolicParaboloidMaterial.cxx
  TestHyperTreeGridExtractGhostCells.cxx,NO_VALID,NO_OUTPUT
  TestHyperTreeGridGeometryPassCellIds.cxx
  TestHyperTreeGridRemoveGhostCells.cxx,NO_VALID,NO_OUTPUT
  TestHyperTreeGridTernary2D.cxx
  TestHyperTreeGridTernary2DBiMaterial.cxx
  TestHyperTreeGridTernary2DFullMaterialBits.cxx
  TestHyperTreeGridTernary2DMaterial.cxx
  TestHyperTreeGridTernary2DMaterialBits.cxx
  TestHyperTreeGridTernary3DAxisClipBox.cxx
  TestHyperTreeGridTernary3DAxisClipCylinder.cxx
  TestHyperTreeGridTernary3DAxisClipPlanes.cxx
  TestHyperTreeGridTernary3DAxisCut.cxx
  TestHyperTreeGridTernary3DAxisCutMaterial.cxx
  TestHyperTreeGridTernary3DAxisReflectionXCenter.cxx
  TestHyperTreeGridTernary3DAxisReflectionXCenterMaterial.cxx
  TestHyperTreeGridTernary3DAxisReflectionYZCenter.cxx
  TestHyperTreeGridTernary3DAxisReflectionYZCenterMaterial.cxx
  TestHyperTreeGridTernary3DCellCenters.cxx
  TestHyperTreeGridTernary3DCellCentersMaterial.cxx
  TestHyperTreeGridTernary3DClip.cxx
  TestHyperTreeGridTernary3DContour.cxx
  TestHyperTreeGridTernary3DContourMaterial.cxx
  TestHyperTreeGridTernary3DDualContour.cxx
  TestHyperTreeGridTernary3DDualContourMaterial.cxx
  TestHyperTreeGridTernary3DGeometry.cxx
# TestHyperTreeGridTernary3DGeometryLargeMaterialBits.cxx #19221
  TestHyperTreeGridTernary3DGeometryMaterial.cxx
  TestHyperTreeGridTernary3DGeometryMaterialBits.cxx
  TestHyperTreeGridTernary3DGradient.cxx
  TestHyperTreeGridTernary3DPlaneCutter.cxx
  TestHyperTreeGridTernary3DPlaneCutterDual.cxx
  TestHyperTreeGridTernary3DPlaneCutterDualMaterial.cxx
  TestHyperTreeGridTernary3DPlaneCutterMaterial.cxx
  TestHyperTreeGridTernary3DThreshold.cxx
  TestHyperTreeGridTernary3DThresholdDeep.cxx
  TestHyperTreeGridTernary3DThresholdImplicit.cxx
  TestHyperTreeGridTernary3DThresholdMaterial.cxx
  TestHyperTreeGridTernary3DThresholdMaterialDeep.cxx
  TestHyperTreeGridTernary3DThresholdMaterialImplicit.cxx
  TestHyperTreeGridTernary3DUnstructured.cxx
  TestHyperTreeGridTernary3DUnstructuredMaterial.cxx
  TestHyperTreeGridTernaryHyperbola.cxx
  TestHyperTreeGridTernarySphereMaterial.cxx
  TestHyperTreeGridTernarySphereMaterialReflections.cxx
  TestHyperTreeGridToDualGrid.cxx
  TestHyperTreeGridVisibleLeavesSize.cxx,NO_VALID,NO_OUPUT
  )

vtk_add_test_cxx(vtkFiltersHyperTreeCxxTests tests ${test_sources})
vtk_test_cxx_executable(vtkFiltersHyperTreeCxxTests tests)

=== VTK/Rendering/Core/Testing/Cxx/CMakeLists.txt ===
set(extra_opengl2_tests)
if (VTK_DEFAULT_RENDER_WINDOW_OFFSCREEN)
  list(APPEND extra_opengl2_tests TestOffscreenIsOffscreen.cxx,NO_DATA,NO_VALID)
endif()
if (VTK_USE_X)
  list(APPEND extra_opengl2_tests TestInteractorTimers.cxx,NO_VALID)
endif()

if (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  set(_vtk_test_cxx_wasm_enabled_in_browser ON)
  set(_proxy_to_pthread_flag "0")
  if (VTK_WEBASSEMBLY_THREADS)
    set(_proxy_to_pthread_flag "1")
  endif ()
  set(_vtk_test_emscripten_extra_linker_args
    # O2 or higher make wasm-opt terribly slow.
    # test executables take a minute to link.
    "-O1"
    # don't keep runtime alive after exit() is called.
    "-sEXIT_RUNTIME=1"
    # this flag runs main() on a pthread i.e, a web worker.
    # the primary reason we desire this is to make the unit test access
    # data files through synchronous XHR which is only posssible from web-worker.
    "-sPROXY_TO_PTHREAD=${_proxy_to_pthread_flag}"
    "-sALLOW_MEMORY_GROWTH=1"
    "-sOFFSCREENCANVAS_SUPPORT=${_proxy_to_pthread_flag}")
endif ()

vtk_add_test_cxx(vtkRenderingCoreCxxTests tests
  ${extra_opengl2_tests}
  FrustumClip.cxx
  Mace.cxx
  otherCoordinate.cxx,NO_DATA,NO_VALID
  otherLookupTable.cxx,NO_VALID
  otherLookupTableWithEnabling.cxx,NO_VALID
  RenderNonFinite.cxx
  RGrid.cxx
# SurfacePlusEdges.cxx #19221
  TestActor2D.cxx
  TestActor2DTextures.cxx
  TestActorLightingFlag.cxx
  TestAnimationScene.cxx
  TestAreaSelections.cxx
  TestAssemblyBounds.cxx,NO_VALID
  TestBackfaceCulling.cxx
  TestBareScalarsToColors.cxx
  TestBackfaceTexture.cxx
  TestBlockOpacity.cxx
  TestBlockVisibility.cxx
  TestColorByCellDataStringArray.cxx
  TestColorByPointDataStringArray.cxx
  TestColorByStringArrayDefaultLookupTable.cxx
  TestColorByStringArrayDefaultLookupTable2D.cxx
  TestColorTransferFunction.cxx,NO_VALID
  TestColorTransferFunctionStringArray.cxx,NO_VALID
  TestCompositeDataDisplayAttributes.cxx,NO_VALID
  TestCompositePolyDataMapper.cxx,NO_DATA
  TestCompositePolyDataMapperCameraShiftScale.cxx,NO_DATA
  TestCompositePolyDataMapperCellScalars.cxx,NO_DATA
  TestCompositePolyDataMapperCustomShader.cxx,NO_DATA
  TestCompositePolyDataMapperMixedGeometryCellScalars.cxx,NO_DATA
  TestCompositePolyDataMapperMixedGeometryEdges.cxx,NO_DATA
  TestCompositePolyDataMapperNaNPartial.cxx,NO_DATA
  TestCompositePolyDataMapperOverrideScalarArray.cxx,NO_DATA
  TestCompositePolyDataMapperOverrideLUT.cxx,NO_DATA
  TestCompositePolyDataMapperPartialFieldData.cxx,NO_DATA
  TestCompositePolyDataMapperPartialPointData.cxx,NO_DATA
  TestCompositePolyDataMapperPickability.cxx,NO_DATA
  TestCompositePolyDataMapperPicking.cxx,NO_DATA
  TestCompositePolyDataMapperScalars.cxx,NO_DATA
# TestCompositePolyDataMapperScalarsSurfaceOpacity.cxx,NO_DATA #19221
  TestCompositePolyDataMapperSharedArray.cxx,NO_DATA
  TestCompositePolyDataMapperStaticBounds.cxx,NO_DATA,NO_VALID
  TestCompositePolyDataMapperSpheres.cxx,NO_DATA
  TestCompositePolyDataMapperToggleScalarVisibilities.cxx,NO_DATA
  TestCompositePolyDataMapperVertices.cxx,NO_DATA
  TestDirectScalarsToColors.cxx
  TestDiscretizableColorTransferFunction.cxx,NO_VALID
  TestDiscretizableColorTransferFunctionOpacity.cxx,NO_VALID
  TestDiscretizableColorTransferFunctionStringArray.cxx,NO_VALID
  TestDragEvent.cxx
  TestEdgeFlags.cxx
  TestEdgeOpacity.cxx
  TestFollowerPicking.cxx
  TestGlyph3DMapper.cxx
  TestGlyph3DMapper2.cxx,NO_VALID,NO_RT,NO_DATA
  TestGlyph3DMapperArrow.cxx
  TestGlyph3DMapperBackfaceColor.cxx
  TestGlyph3DMapperCompositeDisplayAttributeInheritance.cxx,NO_DATA
  TestGlyph3DMapperIndexing.cxx,NO_DATA
  TestGlyph3DMapperMasking.cxx
  TestGlyph3DMapperOrientationArray.cxx
  TestGlyph3DMapperPicking.cxx
  TestGlyph3DMapperQuaternionArray.cxx
  TestGlyph3DMapperTreeIndexing.cxx,NO_DATA
  TestGradientBackground.cxx
  TestGradientBackgroundWithTiledViewport.cxx,NO_DATA
  TestGradientBackgroundWithTiledViewports.cxx,NO_DATA
  TestHomogeneousTransformOfActor.cxx
  TestImageAndAnnotations.cxx,NO_DATA
  TestInteractorStyleImageProperty.cxx,NO_VALID
  TestLabeledContourMapper.cxx
  TestLabeledContourMapperNoLabels.cxx
  TestLabeledContourMapperWithActorMatrix.cxx
  TestManyActors.cxx,NO_VALID
  TestMapVectorsAsRGBColors.cxx
  TestMapVectorsToColors.cxx
  TestMixedGeometryCellScalars.cxx,NO_DATA
  TestOffAxisStereo.cxx
  TestOnAndOffScreenConeCxx.cxx
  TestOpacity.cxx
  TestOrderedTriangulator.cxx
  TestOSConeCxx.cxx
  TestPickingManager.cxx,NO_VALID
  TestPickTextActor.cxx,NO_VALID
  TestPointSelection.cxx,NO_VALID
  TestPointSelectionWithCellData.cxx,NO_VALID
  TestPolygonSelection.cxx
  TestPolyDataMapperNormals.cxx
  TestRenderLinesAsTubes.cxx
  TestResetCameraScreenSpace.cxx
  TestResetCameraVerticalAspectRatio.cxx
  TestResetCameraVerticalAspectRatioParallel.cxx
  TestSelectVisiblePoints.cxx,NO_VALID
  TestSplitViewportStereoHorizontal.cxx
  TestStereoBackgroundLeft.cxx
  TestStereoBackgroundRight.cxx
  TestStereoEyeSeparation.cxx
  TestTexturedBackground.cxx
  TestTexturedCylinder.cxx
  TestTextureRGBA.cxx
  TestTextureRGBADepthPeeling.cxx
  TestTextureSize.cxx,NO_VALID
  TestTilingCxx.cxx
  TestToggleOSWithInteractor.cxx,NO_DATA
  TestTransformCoordinateUseDouble.cxx
  TestTranslucentImageActorAlphaBlending.cxx
  TestTranslucentImageActorDepthPeeling.cxx
  TestTranslucentLUTAlphaBlending.cxx
  TestTranslucentLUTDepthPeeling.cxx
  TestTranslucentLUTTextureAlphaBlending.cxx
  TestTranslucentLUTTextureDepthPeeling.cxx
  TestTStripsColorsTCoords.cxx
  TestTStripsNormalsColorsTCoords.cxx
  TestTStripsNormalsTCoords.cxx
  TestTStripsTCoords.cxx
  TestTupleInterpolator.cxx,NO_VALID,NO_DATA
  TestWindowToImageFilter.cxx
  TestResizingWindowToImageFilter.cxx
  TestTextureWrap.cxx
  # TestViewDependentErrorMetric.cxx # Loads of extra deps - move?
  # TestHierarchicalBoxPipeline.cxx  # legacy code
  )

set_source_files_properties(
  TestEdgeFlags.cxx # fails on OpenGL Mesa
  PROPERTIES COMPILE_FLAGS -DVTK_OPENGL2)

if (VTK_USE_X)
  set_tests_properties(VTK::RenderingCoreCxx-TestInteractorTimers
     PROPERTIES RUN_SERIAL ON)
endif ()

vtk_test_cxx_executable(vtkRenderingCoreCxxTests tests)

=== VTK/Rendering/OpenGL2/Testing/Cxx/CMakeLists.txt ===
vtk_module_test_data(
  Data/pen_1.cur
  Data/pen_1.xcursor
  Data/overlap_faces.vtm
  Data/overlap_faces/overlap_faces_0_0.vtp
  Data/overlap_faces/overlap_faces_1_0.vtp
  Data/overlap_faces/overlap_faces_2_0.vtp
  )

if (CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
  set(_vtk_test_cxx_wasm_enabled_in_browser ON)
  set(_proxy_to_pthread_flag "0")
  if (VTK_WEBASSEMBLY_THREADS)
    set(_proxy_to_pthread_flag "1")
  endif ()
  set(_vtk_test_emscripten_extra_linker_args
    # O2 or higher make wasm-opt terribly slow.
    # test executables take a minute to link.
    "-O1"
    # don't keep runtime alive after exit() is called.
    "-sEXIT_RUNTIME=1"
    # this flag runs main() on a pthread i.e, a web worker.
    # the primary reason we desire this is to make the unit test access
    # data files through synchronous XHR which is only posssible from web-worker.
    "-sPROXY_TO_PTHREAD=${_proxy_to_pthread_flag}"
    "-sALLOW_MEMORY_GROWTH=1"
    "-sOFFSCREENCANVAS_SUPPORT=${_proxy_to_pthread_flag}")
endif ()
vtk_add_test_cxx(vtkRenderingOpenGL2CxxTests tests
  TestBlockVisibility.cxx
  TestBlurAndSobelPasses.cxx
  TestCameraShiftScale.cxx,NO_DATA
  TestCoincident.cxx
  TestCoincidentFloor.cxx
  TestCompositeDataOverlappingCells.cxx,
  TestCompositeDataPointGaussian.cxx,NO_DATA
  TestCompositeDataPointGaussianSelection.cxx,NO_DATA
  TestCompositePolyDataMapper2.cxx,NO_DATA
  TestCompositePolyDataMapper2CameraShiftScale.cxx,NO_DATA
  TestCompositePolyDataMapper2CellScalars.cxx,NO_DATA
  TestCompositePolyDataMapper2CustomShader.cxx,NO_DATA
  TestCompositePolyDataMapper2MixedGeometryCellScalars.cxx,NO_DATA
  TestCompositePolyDataMapper2MixedGeometryEdges.cxx,NO_DATA
  TestCompositePolyDataMapper2NaNPartial.cxx,NO_DATA
  TestCompositePolyDataMapper2PartialFieldData.cxx,NO_DATA
  TestCompositePolyDataMapper2PartialPointData.cxx,NO_DATA
  TestCompositePolyDataMapper2Pickability.cxx,NO_DATA
  TestCompositePolyDataMapper2Picking.cxx,NO_DATA
  TestCompositePolyDataMapper2Scalars.cxx,NO_DATA
# TestCompositePolyDataMapper2ScalarsSurfaceOpacity.cxx,NO_DATA #19221
  TestCompositePolyDataMapper2SharedArray.cxx,NO_DATA
  TestCompositePolyDataMapper2Spheres.cxx,NO_DATA
  TestCompositePolyDataMapper2Vertices.cxx,NO_DATA
  TestComputeShader.cxx,NO_DATA,NO_VALID,NO_OUTPUT
  TestCubeMap.cxx
  TestCubeMap2.cxx
  TestCubeMapRerender.cxx
  TestCustomCursorShape.cxx,NO_VALID
  TestDepthOfFieldPass.cxx
  TestDepthPeelingOcclusionQuery.cxx
  TestDepthPeelingPass.cxx
  TestDepthPeelingPassViewport.cxx
  TestEDLPass.cxx
  TestEquirectangularToCubeMap.cxx
  TestFXAAFilter.cxx
  TestFXAAPass.cxx
  TestFXAAWithEDLPass.cxx
  TestFlipRenderFramebuffer.cxx
  TestFloor.cxx, LOOSE_VALID
  TestFluidMapper.cxx
  TestFramebufferHDR.cxx
  TestFramebufferPass.cxx
  TestGaussianBlurPass.cxx
  TestGlyph3DMapperCellPicking.cxx
  TestGlyph3DMapperCulling.cxx
  TestGlyph3DMapperEdges.cxx
  TestGlyph3DMapperPickability.cxx,NO_DATA
  TestGlyph3DMapperTreeIndexingCompositeGlyphs.cxx,NO_DATA
  TestHiddenLineRemovalPass.cxx
  TestLightingMapLuminancePass.cxx
  TestLightingMapNormalsPass.cxx
  TestMultiTexturing.cxx
  TestMultiTexturingInterpolateScalars.cxx
  TestNormalMapping.cxx
  TestNormalMappingWithEdges.cxx
  TestOffscreenRenderingResize.cxx
  TestOutlineGlowPass.cxx
  TestOrderIndependentTranslucentPass.cxx
  TestPanoramicProjectionPass.cxx,NO_DATA
  TestPBRClearCoat.cxx
  TestPBREdgeTint.cxx
  TestPBRHdrEnvironment.cxx
  TestPBRAnisotropy.cxx
  TestPBRColorMultiplier.cxx
  TestPBRIrradianceHDR.cxx
  TestPBRMapping.cxx
  TestPBRMaterials.cxx
  TestPBRMaterialsCoat.cxx
  TestPBRTextureInterpolateScalars.cxx
  TestPointFillPass.cxx
  TestPointGaussianMapper.cxx
  TestPointGaussianMapperAnisotropic.cxx
  TestPointGaussianMapperOpacity.cxx
  TestPointGaussianSelection.cxx,NO_DATA
  TestProgramPointSize.cxx
  TestPropPicker2Renderers.cxx,NO_DATA
  TestRemoveActorNonCurrentContext.cxx
  TestRenderToImage.cxx
  TestSetZBuffer.cxx
  TestShadowMapBakerPass.cxx
  TestShadowMapPass.cxx
  TestSharedRenderWindow.cxx
  TestDirectSelectionRendering.cxx
  TestSimpleMotionBlur.cxx
  TestSobelGradientMagnitudePass.cxx
  TestSphereMap.cxx
  TestSpherePoints.cxx
  TestSphereVertex.cxx
  TestSRGB.cxx
  TestSSAAPass.cxx
  TestSSAOPass.cxx
  TestSSAOPassWithRenderer.cxx
  TestSurfaceInterpolationSwitch.cxx
  TestTessellationShader.cxx,NO_DATA
  TestTexture16Bits.cxx,NO_DATA
  TestTexture32Bits.cxx,NO_DATA
  TestTextureBufferEmulation.cxx,NO_DATA,NO_VALID,NO_OUTPUT
  TestTextureInterpolateScalars.cxx
  TestToneMappingPass.cxx,NO_DATA
  TestUserShader.cxx
  TestUserShader2.cxx
  TestUserShader2D.cxx,NO_DATA
  TestValuePassFloatingPoint.cxx
  TestValuePassFloatingPoint2.cxx
  TestVBOPLYMapper.cxx
  TestVBOPointsLines.cxx
  TestWindowBlits.cxx
  UnitTestOpenGLUniforms.cxx,NO_DATA,NO_VALID,NO_OUTPUT
  )

# Allow local customization of timeout for this test.
if(NOT VTK_TEST_TIMEOUT_TestFramebufferHDR)
  set(VTK_TEST_TIMEOUT_TestFramebufferHDR 300)
endif()
set_tests_properties(VTK::RenderingOpenGL2Cxx-TestFramebufferHDR
  PROPERTIES TIMEOUT ${VTK_TEST_TIMEOUT_TestFramebufferHDR})

if (VTK_USE_SDL2)
  vtk_add_test_cxx(vtkRenderingOpenGL2CxxTests tests TestSDL2.cxx)
endif ()

if (VTK_USE_WIN32_OPENGL)
  vtk_add_test_cxx(vtkRenderingOpenGL2CxxTests tests
    TestWin32OpenGLDXRenderWindow.cxx)
endif ()

vtk_test_cxx_executable(vtkRenderingOpenGL2CxxTests tests
  DISABLE_FLOATING_POINT_EXCEPTIONS
  RENDERING_FACTORY
  )

if (VTK_USE_WIN32_OPENGL)
  # TestWin32OpenGLDXRenderWindow requires DirectX
  find_package(DirectX REQUIRED)
  target_link_libraries(vtkRenderingOpenGL2CxxTests PRIVATE DirectX::d3d11 DirectX::dxgi)
endif ()

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=paraview
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.13.3
pkgrel=1
pkgdesc="Parallel Data Analysis and Visualization Application based on VTK. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.paraview.org/'
msys2_repository_url="https://gitlab.kitware.com/paraview/paraview"
msys2_references=(
  'archlinux: paraview'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-cgns"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-gdal"
         "${MINGW_PACKAGE_PREFIX}-gl2ps"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libogg"
         "${MINGW_PACKAGE_PREFIX}-liblas"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtheora"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-openturns"
         "${MINGW_PACKAGE_PREFIX}-pdal"
         #"${MINGW_PACKAGE_PREFIX}-pegtl" https://gitlab.kitware.com/vtk/vtk/-/issues/18151
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-qt6-5compat"
         "${MINGW_PACKAGE_PREFIX}-qt6-base"
         "${MINGW_PACKAGE_PREFIX}-qt6-svg"
         "${MINGW_PACKAGE_PREFIX}-qt6-tools"
         "${MINGW_PACKAGE_PREFIX}-vtk")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-python-numpy"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-nlohmann-json")
optdepends=("${MINGW_PACKAGE_PREFIX}-python-numpy"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib")
source=("https://www.paraview.org/files/v${pkgver%.*}/ParaView-v${pkgver}.tar.xz"
        "001-replace-vtk-glew-with-vtk-glad.patch::https://gitlab.kitware.com/paraview/paraview/-/commit/6e762b79d09ce3188992695a3817d5e166fec47f.patch"
        "002-replace-vtk-opengl-with-vtk-glad.patch::https://gitlab.kitware.com/paraview/paraview/-/commit/53bcd8cd82bfcd43813fc493bde7726272a28f40.patch"
        "003-replace-glew-includes-with-glad.patch::https://gitlab.kitware.com/paraview/paraview/-/commit/a5fe98f96e286e576235abb53053798cfd53512c.patch"
        "004-forward-opengl-context-init.patch::https://gitlab.kitware.com/paraview/paraview/-/commit/455fd10d7b0445e8cb63184665bf2b5a3810be16.patch"
        "005-fix-build-with-cli11-2.5.0.patch::https://gitlab.kitware.com/paraview/paraview/-/commit/e6b14df7.patch")
sha256sums=('3bd31bb56e07aa2af2a379895745bbc430c565518a363d935f2efc35b076df09'
            'a24c6162eda682d4eeb750432915711884e85dba6a55bf6222862ae0aa862611'
            'f8f1a79549e626cf25ea0f6ee9a3386a642690d5423d798833d4092f2a38c061'
            'eeb21c4afd826860173f4aa13b240eb86dc312a5601c566cd0880bd8f65255f5'
            'f87de9565bc6ef6b149b62c911a4d723ca6f6ae783a60ff66a1039080190f841'
            'cb4c65fa3de357d5344629b113d2bfd679548c2b760a60787ef52856ee98a260')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/ParaView-v${pkgver}

  apply_patch_with_msg \
    001-replace-vtk-glew-with-vtk-glad.patch \
    002-replace-vtk-opengl-with-vtk-glad.patch \
    003-replace-glew-includes-with-glad.patch \
    004-forward-opengl-context-init.patch \
    005-fix-build-with-cli11-2.5.0.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys; print(f'{sys.version_info.major}.{sys.version_info.minor}')")

  CXXFLAGS+=" -w -Wno-register" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DPARAVIEW_BUILD_SHARED_LIBS=ON \
      -DPARAVIEW_USE_PYTHON=ON \
      -DPARAVIEW_USE_QT=ON \
      -DPARAVIEW_USE_MPI=OFF \
      -DPARAVIEW_ENABLE_GDAL=ON \
      -DPARAVIEW_ENABLE_LAS=ON \
      -DPARAVIEW_ENABLE_OPENTURNS=ON \
      -DPARAVIEW_ENABLE_PDAL=ON \
      -DPARAVIEW_VERSIONED_INSTALL=OFF \
      -DPARAVIEW_CUSTOM_LIBRARY_SUFFIX="pv${pkgver%.*}" \
      -DPARAVIEW_BUILD_WITH_EXTERNAL=ON \
      -DPARAVIEW_PYTHON_SITE_PACKAGES_SUFFIX="lib/python${_pyver}/site-packages/pv/" \
      -DPARAVIEW_IGNORE_CMAKE_CXX11_CHECKS=ON \
      -DPARAVIEW_USE_EXTERNAL_VTK=ON \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      ../ParaView-v${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
    -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib/python"*

  install -Dm644 "${srcdir}/ParaView-v${pkgver}/Copyright.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
